// B25Decoder.cpp: CCB25Decoder NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include <Windows.h>
#include "B25Decoder.h"
#include "marumo\\arib_std_b25_error_code.h"

#pragma comment(lib, "winscard.Lib")


//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

#pragma warning( disable : 4273 )

extern "C" __declspec(dllexport) DWORD GetB25Version(void)
{
	// x[XɂȂĂ marumõo[W(PUiQ)
	// 0.1.15 = 0x000115
	// 0.2.1  = 0x000201
	// 1.0.0  = 0x010201
	return 0x000201;
}

extern "C" __declspec(dllexport) IB25Decoder * CreateB25Decoder()
{
	// X^X(̏ꍇ̓CX^X̃|C^Ԃ)
	return (CB25Decoder::m_pThis)? CB25Decoder::m_pThis : ((IB25Decoder *) new CB25Decoder);
}

extern "C" __declspec(dllexport) IB25DecoderEx * CreateB25DecoderEx()
{
	// X^X(̏ꍇ̓CX^X̃|C^Ԃ)
	return (CB25DecoderMarumo::m_pThis)? CB25DecoderMarumo::m_pThis : ((IB25DecoderEx *) new CB25DecoderMarumo);
}

#pragma warning( default : 4273 )


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// ÓIo
CB25Decoder * CB25Decoder::m_pThis = NULL;
CB25DecoderMarumo * CB25DecoderMarumo::m_pThis = NULL;

CB25Decoder::CB25Decoder()
{
	m_pThis = this;

	// IuWFNg
	m_pB25 = NULL;
	m_pBcas = NULL;
}

CB25DecoderMarumo::CB25DecoderMarumo()
{
	m_pThis = this;

	// IuWFNg
	m_pB25 = NULL;
	m_pBcas = NULL;
	// IvV
	m_bEMM = FALSE;
}

CB25Decoder::~CB25Decoder()
{
	// IuWFNgJ
	ReleaseObjects();

	m_pThis = NULL;
}

CB25DecoderMarumo::~CB25DecoderMarumo()
{
	// IuWFNgJ
	ReleaseObjects();

	m_pThis = NULL;
}

const BOOL CB25Decoder::Initialize(DWORD dwRound)
{
	ReleaseObjects();

	// B25fR[_CX^X
	if(!(m_pB25 = create_arib_std_b25())){
		return FALSE;
		}

	// B25fR[_IvVݒ
	if(m_pB25->set_multi2_round(m_pB25, dwRound) < 0){
		ReleaseObjects();
		return FALSE;
		}

	// IvVݒ(EMM)
	if(m_pB25->set_emm_proc(m_pB25, 0) < 0){
		ReleaseObjects();
		return FALSE;
		}
	// IvVݒ(nulljȂ)
	if(m_pB25->set_strip(m_pB25, 0) < 0){
		ReleaseObjects();
		return FALSE;
		}

	// B-CASJ[hCX^X
	if(!(m_pBcas = create_b_cas_card())){
		ReleaseObjects();
		return FALSE;
		}

	//@B-CASJ[h
	if(m_pBcas->init(m_pBcas) < 0){
		ReleaseObjects();
		return FALSE;
		}
	
	// B25B-CASJ[hA^b`
	if(m_pB25->set_b_cas_card(m_pB25, m_pBcas) < 0){
		ReleaseObjects();
		return FALSE;
		}

	return TRUE;
}

const BOOL CB25DecoderMarumo::SetOpeion(DWORD dwOpt,DWORD dwData)
{
	switch(dwOpt){
	case B25_OPTION_EMM:
		m_bEMM = dwData ? TRUE : FALSE;
		break;
	default:
		return FALSE;
		}
	return TRUE;
}

const BOOL CB25DecoderMarumo::Initialize(DWORD dwRound)
{
	ReleaseObjects();

	// B25fR[_CX^X
	if(!(m_pB25 = create_arib_std_b25())){
		return FALSE;
		}

	// B25fR[_IvVݒ
	if(m_pB25->set_multi2_round(m_pB25, dwRound) < 0){
		ReleaseObjects();
		return FALSE;
		}

	// IvVݒ(EMM)
	if(m_pB25->set_emm_proc(m_pB25, m_bEMM ? 1 : 0) < 0){
		ReleaseObjects();
		return FALSE;
		}
	// IvVݒ(nulljȂ)
	if(m_pB25->set_strip(m_pB25, 0) < 0){
		ReleaseObjects();
		return FALSE;
		}

	// B-CASJ[hCX^X
	if(!(m_pBcas = create_b_cas_card())){
		ReleaseObjects();
		return FALSE;
		}

	//@B-CASJ[h
	if(m_pBcas->init(m_pBcas) < 0){
		ReleaseObjects();
		return FALSE;
		}
	
	// B25B-CASJ[hA^b`
	if(m_pB25->set_b_cas_card(m_pB25, m_pBcas) < 0){
		ReleaseObjects();
		return FALSE;
		}

	return TRUE;
}

void CB25Decoder::ReleaseObjects(void)
{
	// B25fR[_CX^XJ
	if(m_pB25){
		m_pB25->release(m_pB25);
		m_pB25 = NULL;
		}

	// B-CASJ[hCX^XJ
	if(m_pBcas){
		m_pBcas->release(m_pBcas);
		m_pBcas = NULL;
		}
}

void CB25DecoderMarumo::ReleaseObjects(void)
{
	// B25fR[_CX^XJ
	if(m_pB25){
		m_pB25->release(m_pB25);
		m_pB25 = NULL;
		}

	// B-CASJ[hCX^XJ
	if(m_pBcas){
		m_pBcas->release(m_pBcas);
		m_pBcas = NULL;
		}
}

void CB25Decoder::Release()
{
	// CX^XJ
	delete this;
}

void CB25DecoderMarumo::Release()
{
	// CX^XJ
	delete this;
}

const BOOL CB25Decoder::Decode(BYTE *pSrcBuf, const DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!m_pB25 || !pSrcBuf || !pdwDstSize || !ppDstBuf)return FALSE;

	// obt@Zbg
	m_SrcBuf.data = pSrcBuf;
	m_SrcBuf.size = dwSrcSize;

	// ÍTSf[^
	if(m_pB25->put(m_pB25, &m_SrcBuf) < 0){
		return FALSE;
		}

	// TSf[^擾
	if(m_pB25->get(m_pB25, &m_DstBuf) < 0){
		return FALSE;
		}

	// o͏Rs[
	*ppDstBuf = m_DstBuf.data;
	*pdwDstSize = m_DstBuf.size;

	return TRUE;
}

const DWORD CB25DecoderMarumo::Decode(BYTE *pSrcBuf, const DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!m_pB25 || !pSrcBuf || !pdwDstSize || !ppDstBuf)return B25_DECORD_FAILED;

	// obt@Zbg
	m_SrcBuf.data = pSrcBuf;
	m_SrcBuf.size = dwSrcSize;

	// ÍTSf[^
	int ret = m_pB25->put(m_pB25, &m_SrcBuf);
	if( ret < 0){
		switch(ret)
		{
		case ARIB_STD_B25_ERROR_NON_TS_INPUT_STREAM:
			// Xg[܂܂ĂȂƐ
			break;
		default:
			return B25_DECORD_PUT_ERROR;
			}		
		}

	// TSf[^擾
	if(m_pB25->get(m_pB25, &m_DstBuf) < 0){
		return B25_DECORD_GET_ERROR;
		}

	// o͏Rs[
	*ppDstBuf = m_DstBuf.data;
	*pdwDstSize = m_DstBuf.size;

	return B25_DECORD_SUCCESS;
}

const BOOL CB25Decoder::Flush(BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!m_pB25 || !pdwDstSize)return FALSE;

	// fR[hcf[^tbV
	if(m_pB25->flush(m_pB25) < 0){
		return FALSE;
		}

	// TSf[^擾
	if(m_pB25->get(m_pB25, &m_DstBuf) < 0){
		return FALSE;
		}

	// o͏Rs[
	*ppDstBuf = m_DstBuf.data;
	*pdwDstSize = m_DstBuf.size;

	return TRUE;
}

const BOOL CB25DecoderMarumo::Flush(BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!m_pB25 || !pdwDstSize)return FALSE;

	// fR[hcf[^tbV
	if(m_pB25->flush(m_pB25) < 0){
		return FALSE;
		}

	// TSf[^擾
	if(m_pB25->get(m_pB25, &m_DstBuf) < 0){
		return FALSE;
		}

	// o͏Rs[
	*ppDstBuf = m_DstBuf.data;
	*pdwDstSize = m_DstBuf.size;

	return TRUE;
}

const BOOL CB25Decoder::Reset(void)
{
	if(!m_pB25)return FALSE;

	// B25fR[_Zbg
	if(m_pB25->reset(m_pB25) < 0){
		return FALSE;
		}

	return TRUE;
}

const BOOL CB25DecoderMarumo::Reset(void)
{
	if(!m_pB25)return FALSE;

	// B25fR[_Zbg
	if(m_pB25->reset(m_pB25) < 0){
		return FALSE;
		}

	return TRUE;
}