// B25Decoder.h: CB25Decoder NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_B25DECODER_H_)
#define _B25DECODER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Marumo/arib_std_b25.h"
#include "Marumo/b_cas_card.h"
#include "IB25Decoder.h"

// IWi
class CB25Decoder : public IB25Decoder
{
public:
	CB25Decoder();
	virtual ~CB25Decoder();

	const BOOL Initialize(DWORD dwRound = 4);
	void Release(void);

	const BOOL Decode(BYTE *pSrcBuf, const DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize);
	const BOOL Flush(BYTE **ppDstBuf, DWORD *pdwDstSize);
	const BOOL Reset(void);

	static CB25Decoder * m_pThis;

protected:
	void ReleaseObjects(void);

	ARIB_STD_B25 *m_pB25;
	B_CAS_CARD   *m_pBcas;

	ARIB_STD_B25_BUFFER m_SrcBuf;
	ARIB_STD_B25_BUFFER m_DstBuf;
};

// MarumogΉ
class CB25DecoderMarumo  : public IB25DecoderEx
{
public:
	CB25DecoderMarumo();
	virtual ~CB25DecoderMarumo();

	virtual const BOOL SetOpeion(DWORD dwOpt,DWORD dwData);

	const BOOL Initialize(DWORD dwRound = 4);
	void Release(void);

	const DWORD Decode(BYTE *pSrcBuf, const DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize);
	const BOOL Flush(BYTE **ppDstBuf, DWORD *pdwDstSize);
	const BOOL Reset(void);

	static CB25DecoderMarumo * m_pThis;

protected:
	void ReleaseObjects(void);

	ARIB_STD_B25 *m_pB25;
	B_CAS_CARD   *m_pBcas;

	ARIB_STD_B25_BUFFER m_SrcBuf;
	ARIB_STD_B25_BUFFER m_DstBuf;

	BOOL m_bEMM;
};

#endif // !defined(_B25DECODER_H_)
